// Copyright 2008 Brian Caine

// This file is part of Potpourri.

// Potpourri is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Potpourri is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTIBILITY of FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Potpourri. If not, see <http://www.gnu.org/licenses/>.


// NOTES:

// Defines the event structure

#ifndef __EVENT_H
#define __EVENT_H

#include "Variant.h"

#include <string>
#include <map>

namespace fragrant
{
  enum EventType
    {
      ET_Quit,
      ET_Key,
      ET_MouseMotion,
      ET_MouseButton,
      ET_SwitchLevel,
      ET_WMEvent

      // joystick and all that bullshit to be added later
    };

  const std::string NO_RECURSE = "NO_RECURSE";

  const std::string EVENT_DELIM_1 = ":";
  const std::string EVENT_DELIM_2 = ",";
  const std::string EVENT_DELIM_3 = "=";
  const std::string EVENT_DELIM_4 = "-";

  const std::string KEY = "Key";
  const std::string BOOL = "b";
  const std::string CHAR = "c";
  const std::string INT = "i";
  const std::string MOUSEBUTTON = "MouseButton";

// ET_Quit: no params
// ET_Key:
//         `key'	Key	The key pressed
//         `char'	char	key pressed, as a char
//         `pressed'	bool	Pressed, if not, released
// ET_MouseMotion:
//         `state'	int	The state of the buttons
//           `x'	int	The x position
//           `y'	int	The y position
//         `xrel'	int	The x position, relative to last position
//         `yrel'	int	The y relative position
// ET_MouseButton:
//        `button'   MouseButton button pressed
//         `pressed'	bool	pressed, if true
//           `x'	int	The x position
//           `y'	int	The y position
// ET_SwitchLevel:
//        `dest'	int/string The next level or, 0 as an int to quit
// ET_WMEvent:
//        `gain'	int	Whether the state was acquired or lost
//        `state'	int	OR'd value of stuff below

  const std::string EventStringArray[] =
    {
      "ET_Quit",
      "ET_Key",
      "ET_MouseMotion",
      "ET_MouseButton",
      "ET_SwitchLevel",
      "ET_WMEvent"
    };

  const std::string KeyStringArray[] =
    {
      "K_UNKNOWN",
      "K_FIRST",
      "K_BACKSPACE",
      "K_TAB",
      "K_CLEAR",
      "K_RETURN",
      "K_PAUSE",
      "K_ESCAPE",
      "K_SPACE",
      "K_EXCLAIM",
      "K_QUOTEDBL",
      "K_HASH",
      "K_DOLLAR",
      "K_AMPERSAND",
      "K_QUOTE",
      "K_LEFTPAREN",
      "K_RIGHTPAREN",
      "K_ASTERISK",
      "K_PLUS",
      "K_COMMA",
      "K_MINUS",
      "K_PERIOD",
      "K_SLASH",
      "K_0",
      "K_1",
      "K_2",
      "K_3",
      "K_4",
      "K_5",
      "K_6",
      "K_7",
      "K_8",
      "K_9",
      "K_COLON",
      "K_SEMICOLON",
      "K_LESS",
      "K_EQUALS",
      "K_GREATER",
      "K_QUESTION",
      "K_AT",
      "K_LEFTBRACKET",
      "K_BACKSLASH",
      "K_RIGHTBRACKET",
      "K_CARET",
      "K_UNDERSCORE",
      "K_BACKQUOTE",
      "K_a",
      "K_b",
      "K_c",
      "K_d",
      "K_e",
      "K_f",
      "K_g",
      "K_h",
      "K_i",
      "K_j",
      "K_k",
      "K_l",
      "K_m",
      "K_n",
      "K_o",
      "K_p",
      "K_q",
      "K_r",
      "K_s",
      "K_t",
      "K_u",
      "K_v",
      "K_w",
      "K_x",
      "K_y",
      "K_z",
      "K_DELETE",
      "K_WORLD_0",
      "K_WORLD_1",
      "K_WORLD_2",
      "K_WORLD_3",
      "K_WORLD_4",
      "K_WORLD_5",
      "K_WORLD_6",
      "K_WORLD_7",
      "K_WORLD_8",
      "K_WORLD_9",
      "K_WORLD_10",
      "K_WORLD_11",
      "K_WORLD_12",
      "K_WORLD_13",
      "K_WORLD_14",
      "K_WORLD_15",
      "K_WORLD_16",
      "K_WORLD_17",
      "K_WORLD_18",
      "K_WORLD_19",
      "K_WORLD_20",
      "K_WORLD_21",
      "K_WORLD_22",
      "K_WORLD_23",
      "K_WORLD_24",
      "K_WORLD_25",
      "K_WORLD_26",
      "K_WORLD_27",
      "K_WORLD_28",
      "K_WORLD_29",
      "K_WORLD_30",
      "K_WORLD_31",
      "K_WORLD_32",
      "K_WORLD_33",
      "K_WORLD_34",
      "K_WORLD_35",
      "K_WORLD_36",
      "K_WORLD_37",
      "K_WORLD_38",
      "K_WORLD_39",
      "K_WORLD_40",
      "K_WORLD_41",
      "K_WORLD_42",
      "K_WORLD_43",
      "K_WORLD_44",
      "K_WORLD_45",
      "K_WORLD_46",
      "K_WORLD_47",
      "K_WORLD_48",
      "K_WORLD_49",
      "K_WORLD_50",
      "K_WORLD_51",
      "K_WORLD_52",
      "K_WORLD_53",
      "K_WORLD_54",
      "K_WORLD_55",
      "K_WORLD_56",
      "K_WORLD_57",
      "K_WORLD_58",
      "K_WORLD_59",
      "K_WORLD_60",
      "K_WORLD_61",
      "K_WORLD_62",
      "K_WORLD_63",
      "K_WORLD_64",
      "K_WORLD_65",
      "K_WORLD_66",
      "K_WORLD_67",
      "K_WORLD_68",
      "K_WORLD_69",
      "K_WORLD_70",
      "K_WORLD_71",
      "K_WORLD_72",
      "K_WORLD_73",
      "K_WORLD_74",
      "K_WORLD_75",
      "K_WORLD_76",
      "K_WORLD_77",
      "K_WORLD_78",
      "K_WORLD_79",
      "K_WORLD_80",
      "K_WORLD_81",
      "K_WORLD_82",
      "K_WORLD_83",
      "K_WORLD_84",
      "K_WORLD_85",
      "K_WORLD_86",
      "K_WORLD_87",
      "K_WORLD_88",
      "K_WORLD_89",
      "K_WORLD_90",
      "K_WORLD_91",
      "K_WORLD_92",
      "K_WORLD_93",
      "K_WORLD_94",
      "K_WORLD_95",
      "K_KP0",
      "K_KP1",
      "K_KP2",
      "K_KP3",
      "K_KP4",
      "K_KP5",
      "K_KP6",
      "K_KP7",
      "K_KP8",
      "K_KP9",
      "K_KP_PERIOD",
      "K_KP_DIVIDE",
      "K_KP_MULTIPLY",
      "K_KP_MINUS",
      "K_KP_PLUS",
      "K_KP_ENTER",
      "K_KP_EQUALS",
      "K_UP",
      "K_DOWN",
      "K_RIGHT",
      "K_LEFT",
      "K_INSERT",
      "K_HOME",
      "K_END",
      "K_PAGEUP",
      "K_PAGEDOWN",
      "K_F1",
      "K_F2",
      "K_F3",
      "K_F4",
      "K_F5",
      "K_F6",
      "K_F7",
      "K_F8",
      "K_F9",
      "K_F10",
      "K_F11",
      "K_F12",
      "K_F13",
      "K_F14",
      "K_F15",
      "K_NUMLOCK",
      "K_CAPSLOCK",
      "K_SCROLLOCK",
      "K_RSHIFT",
      "K_LSHIFT",
      "K_RCTRL",
      "K_LCTRL",
      "K_RALT",
      "K_LALT",
      "K_RMETA",
      "K_LMETA",
      "K_LSUPER",
      "K_RSUPER",
      "K_MODE",
      "K_COMPOSE",
      "K_HELP",
      "K_PRINT",
      "K_SYSREQ",
      "K_BREAK",
      "K_MENU",
      "K_POWER",
      "K_EURO",
      "K_UNDO"
    };

  enum Key
    {
      K_UNKNOWN,
      K_FIRST,
      K_BACKSPACE,
      K_TAB,
      K_CLEAR,
      K_RETURN,
      K_PAUSE,
      K_ESCAPE,
      K_SPACE,
      K_EXCLAIM,
      K_QUOTEDBL,
      K_HASH,
      K_DOLLAR,
      K_AMPERSAND,
      K_QUOTE,
      K_LEFTPAREN,
      K_RIGHTPAREN,
      K_ASTERISK,
      K_PLUS,
      K_COMMA,
      K_MINUS,
      K_PERIOD,
      K_SLASH,
      K_0,
      K_1,
      K_2,
      K_3,
      K_4,
      K_5,
      K_6,
      K_7,
      K_8,
      K_9,
      K_COLON,
      K_SEMICOLON,
      K_LESS,
      K_EQUALS,
      K_GREATER,
      K_QUESTION,
      K_AT,
      K_LEFTBRACKET,
      K_BACKSLASH,
      K_RIGHTBRACKET,
      K_CARET,
      K_UNDERSCORE,
      K_BACKQUOTE,
      K_a,
      K_b,
      K_c,
      K_d,
      K_e,
      K_f,
      K_g,
      K_h,
      K_i,
      K_j,
      K_k,
      K_l,
      K_m,
      K_n,
      K_o,
      K_p,
      K_q,
      K_r,
      K_s,
      K_t,
      K_u,
      K_v,
      K_w,
      K_x,
      K_y,
      K_z,
      K_DELETE,
      K_WORLD_0,
      K_WORLD_1,
      K_WORLD_2,
      K_WORLD_3,
      K_WORLD_4,
      K_WORLD_5,
      K_WORLD_6,
      K_WORLD_7,
      K_WORLD_8,
      K_WORLD_9,
      K_WORLD_10,
      K_WORLD_11,
      K_WORLD_12,
      K_WORLD_13,
      K_WORLD_14,
      K_WORLD_15,
      K_WORLD_16,
      K_WORLD_17,
      K_WORLD_18,
      K_WORLD_19,
      K_WORLD_20,
      K_WORLD_21,
      K_WORLD_22,
      K_WORLD_23,
      K_WORLD_24,
      K_WORLD_25,
      K_WORLD_26,
      K_WORLD_27,
      K_WORLD_28,
      K_WORLD_29,
      K_WORLD_30,
      K_WORLD_31,
      K_WORLD_32,
      K_WORLD_33,
      K_WORLD_34,
      K_WORLD_35,
      K_WORLD_36,
      K_WORLD_37,
      K_WORLD_38,
      K_WORLD_39,
      K_WORLD_40,
      K_WORLD_41,
      K_WORLD_42,
      K_WORLD_43,
      K_WORLD_44,
      K_WORLD_45,
      K_WORLD_46,
      K_WORLD_47,
      K_WORLD_48,
      K_WORLD_49,
      K_WORLD_50,
      K_WORLD_51,
      K_WORLD_52,
      K_WORLD_53,
      K_WORLD_54,
      K_WORLD_55,
      K_WORLD_56,
      K_WORLD_57,
      K_WORLD_58,
      K_WORLD_59,
      K_WORLD_60,
      K_WORLD_61,
      K_WORLD_62,
      K_WORLD_63,
      K_WORLD_64,
      K_WORLD_65,
      K_WORLD_66,
      K_WORLD_67,
      K_WORLD_68,
      K_WORLD_69,
      K_WORLD_70,
      K_WORLD_71,
      K_WORLD_72,
      K_WORLD_73,
      K_WORLD_74,
      K_WORLD_75,
      K_WORLD_76,
      K_WORLD_77,
      K_WORLD_78,
      K_WORLD_79,
      K_WORLD_80,
      K_WORLD_81,
      K_WORLD_82,
      K_WORLD_83,
      K_WORLD_84,
      K_WORLD_85,
      K_WORLD_86,
      K_WORLD_87,
      K_WORLD_88,
      K_WORLD_89,
      K_WORLD_90,
      K_WORLD_91,
      K_WORLD_92,
      K_WORLD_93,
      K_WORLD_94,
      K_WORLD_95,
      K_KP0,
      K_KP1,
      K_KP2,
      K_KP3,
      K_KP4,
      K_KP5,
      K_KP6,
      K_KP7,
      K_KP8,
      K_KP9,
      K_KP_PERIOD,
      K_KP_DIVIDE,
      K_KP_MULTIPLY,
      K_KP_MINUS,
      K_KP_PLUS,
      K_KP_ENTER,
      K_KP_EQUALS,
      K_UP,
      K_DOWN,
      K_RIGHT,
      K_LEFT,
      K_INSERT,
      K_HOME,
      K_END,
      K_PAGEUP,
      K_PAGEDOWN,
      K_F1,
      K_F2,
      K_F3,
      K_F4,
      K_F5,
      K_F6,
      K_F7,
      K_F8,
      K_F9,
      K_F10,
      K_F11,
      K_F12,
      K_F13,
      K_F14,
      K_F15,
      K_NUMLOCK,
      K_CAPSLOCK,
      K_SCROLLOCK,
      K_RSHIFT,
      K_LSHIFT,
      K_RCTRL,
      K_LCTRL,
      K_RALT,
      K_LALT,
      K_RMETA,
      K_LMETA,
      K_LSUPER,
      K_RSUPER,
      K_MODE,
      K_COMPOSE,
      K_HELP,
      K_PRINT,
      K_SYSREQ,
      K_BREAK,
      K_MENU,
      K_POWER,
      K_EURO,
      K_UNDO
    };

  enum MouseButton
    {
      MB_LEFT              = 0x1,
      MB_MIDDLE            = 0x2,
      MB_RIGHT             = 0x4,
      MB_WHEEL_UP          = 0x8,
      MB_WHEEL_DOWN        = 0x16
    };

  std::map<std::string, MouseButton> makeMouseStringMap();
  const std::map<std::string, MouseButton> MouseStringMap =
    makeMouseStringMap();

  enum WMEventType
    {
      WMET_APPMOUSEFOCUS   = 0x1,
      WMET_INPUTFOCUS      = 0x2,
      WMET_APPACTIVE       = 0x4
    };

  struct Event
    {
      std::string name;
      std::map<std::string, fragrant::Variant*> data;
    };

  bool matchEvent(std::string, Event);
}

#endif
